# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "10" /> 
#<program4xi program = "yoke4xi.py">
#<abstract4xi abstract = "Yokes debug messages"/>
#<refer4xi reference = "ScopeXi"/>
#<note4xi note = "yoke = to join - in this case input to multiple channels"/>   
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'yoke4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    from time import localtime, strftime         
except:
    pass
        
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# ---------------------------------------------------------------------------------------------
# Globals                         
# ---------------------------------------------------------------------------------------------     
global ack2debug
global ack2debug4try
global ack2debug4yoke
global file2scope
global path2scope
global operation2file
global message2xi
global end2line
global status2file

# ---------------------------------------------------------------------------------------------
# SETTINGS                         
# ---------------------------------------------------------------------------------------------     
ack2debug = False 
ack2debug4try = False 
ack2debug4yoke = False 
path2scope = 'pass' 
operation2file = 'pass'
message2xi = 'pass'
end2line = "\n"
status2file = 'closed'  
        
# -------------------------------------------------------------------------------------------------
# yoke4xi
#    
# context parameter:                             
#    context2yoke['path']           = 'pass'
#    context2yoke['operation']      = 'pass'
#    context2yoke['ack2debug']      =  False  # set True to debug actions
#    context2yoke['ack2debug4try']  =  False  # set True to debug also trials
#    context2yoke['ack2debug4yoke'] =  False  # set True when testing yoke4xi !
#    context2yoke['message']        = 'pass'    
# test:
#    yoke4xi (context2yoke)
#    
# usage 1: normal print trace - no file writing
#    context2yoke['operation'] = 'pass'
#    context2yoke['message'] = '<!--' + "(Step 33A/33) OF IMPORT2BALL4XI - TRYING TO CLOSE OUTPUT HTML FILE " + time4xi() + '-->'
#    yoke4xi(context2yoke) 
#
# usage 2: normal print trace and writing to HTML file
#
#    context2yoke['operation'] = 'write'
#    context2yoke['message'] = '</object>'
#    yoke4xi(context2yoke)     
#
# -------------------------------------------------------------------------------------------------    
def yoke4xi (context2yoke = 
    {'path':            'pass',                    # <-- path 
     'operation':       'pass',                    # <-- operation('open', 'write','close')      
     'ack2debug':       False,                     # <-- nack to debug
     'ack2debug4try':   False,                     # <-- nack to debug trials
     'ack2debug4yoke':  False,                     # <-- nack to debug this module
     'message':         'pass'}):                  # <-- message                       
    
    '''
    yokes messages
    '''

    # ---------------------------------------------------------------------------------------------
    # Globals                         
    # ---------------------------------------------------------------------------------------------     
    global ack2debug
    global ack2debug4try
    global ack2debug4yoke
    global file2scope
    global path2scope
    global operation2file
    global message2xi
    global end2line
    global status2file
      
    # ---------------------------------------------------------------------------------------------
    # TAILORING FOR DEBUGGING                   
    # ---------------------------------------------------------------------------------------------       
    keys2context = context2yoke.keys()
    
    if 'ack2debug' in keys2context:
        ack2debug = context2yoke['ack2debug']     
    else:
        pass
    
    if 'ack2debug4try' in keys2context:
        ack2debug4try = context2yoke['ack2debug4try']     
    else:
        pass
    
    if 'ack2debug4yoke' in keys2context:
        ack2debug4yoke = context2yoke['ack2debug4yoke']     
    else:
        pass
        
    # ---------------------------------------------------------------------------------------------
    # TAILORING FOR FILE                         
    # --------------------------------------------------------------------------------------------- 
    if 'path' in keys2context:
        path2scope = context2yoke['path']     
    else:
        pass           
    if 'operation' in keys2context:
        operation2file = context2yoke['operation']     
    else:
        pass
                            
    # ---------------------------------------------------------------------------------------------
    # TAILORING FOR MESSAGE                         
    # ---------------------------------------------------------------------------------------------         
    if 'message' in keys2context:
        message2xi = context2yoke['message']     
    else:
        pass      
    
    # ---------------------------------------------------------------------------------------------
    # START                         
    # ---------------------------------------------------------------------------------------------    
    if ack2debug4yoke is True:
        print(33*("-"))
        print("YOKE4XI: STARTED ", time4xi())                                                                       # 05:22:05 02/01/11 Pacific Standard Time
        print("YOKE4XI: PASSED CONTEXT2YOKE: ", context2yoke)                                                       # {'ack2debug4try': True, 'ack2debug': True, 
                                                                                                                    #  'path':      '..//..//..//web//html//sense-test-zskeleton4xi.html', 
                                                                                                                    #  'operation': 'write', 'message':   '<!DOCTYPE HTML>', 'ack2debug4yoke': True} 
        print("YOKE4XI: SET PATH2SCOPE: ", path2scope)                                                              # ..//..//..//web//html//sense-test-zskeleton4xi.html  
        print("YOKE4XI: SET OPERATION2FILE: ", operation2file)                                                      # write
        print("YOKE4XI: SET MESSAGE2XI: ", message2xi)                                                              # <!DOCTYPE HTML>
        print(33*("-"))                           
        
    # ---------------------------------------------------------------------------------------------
    # FILE                
    # ---------------------------------------------------------------------------------------------     
    if operation2file == 'write':
        if ack2debug4try is True:
            print("YOKE4XI: TRYING TO WRITE TO FILE PATH2SCOPE: ", path2scope)
        try:
            # -------------------------------------------------------------------------------------
            # WRITE                
            # -------------------------------------------------------------------------------------             
            if message2xi == 'pass':
                pass
            else:    
                line2write = message2xi + end2line
                if status2file == 'closed':
                    file2scope = open(path2scope, 'w')          
                    status2file = 'open'
      
                file2scope.write(line2write)
                if ack2debug is True:
                    print("YOKE4XI - WROTE: ", line2write)

        except:
            print("YOKE4XI: *** FAILED TO WRITE TO FILE - PATH2SCOPE: ", path2scope, " CONTEXT2YOKE: ", context2yoke)

    if ((operation2file == 'open') and (status2file == 'closed')):
        if ack2debug4try is True:
            print("YOKE4XI: TRYING TO OPEN FILE - PATH2SCOPE: ", path2scope) 
        # -------------------------------------------------------------------------------------
        # OPEN                
        # -------------------------------------------------------------------------------------             
        try:
            file2scope = open(path2scope, 'w')
            status2file = 'open'
            if ack2debug is True:
                print("YOKE4XI: OPENED FILE - FILE2SCOPE: ", file2scope, " PATH2SCOPE: ", path2scope)               # <_io.TextIOWrapper name='..//..//..//web//html//sense-test-zskeleton4xi.html' encoding='cp1252'>  PATH2SCOPE:  ..//..//..//web//html//sense-test-zskeleton4xi.html
                
        except:
            print("YOKE4XI: *** FAILED TO OPEN FILE - PATH2SCOPE: ", path2scope, " CONTEXT2YOKE: ", context2yoke) 
            
    if operation2file == 'close':
        if ack2debug4try is True:
            print("YOKE4XI: TRYING TO CLOSE FILE PATH2SCOPE: ", path2scope())    
        # -------------------------------------------------------------------------------------
        # CLOSE                
        # -------------------------------------------------------------------------------------          
        try:
            file2scope.close() 
            if ack2debug is True:
                print("YOKE4XI: CLOSED FILE - PATH2SCOPE: ", path2scope)
        except:
            print("YOKE4XI: *** FAILED TO CLOSE FILE - PATH2SCOPE: ", path2scope)         

    if operation2file == 'pass':
        pass
                
    # ---------------------------------------------------------------------------------------------
    # PRINT                
    # ---------------------------------------------------------------------------------------------     
    if message2xi == 'pass':
        pass
    else:
        if ack2debug4try is True:
            print("YOKE4XI: TRYING TO PRINT ", time4xi())                                                           # 05:34:09 02/01/11 Pacific Standard Time  
        try:        
            print(message2xi)
        except:
            print("YOKE4XI: *** FAILED TO PRINT MESSAGE - CONTEXT2YOKE: ", context2yoke)

    # ---------------------------------------------------------------------------------------------
    # RETURN                         
    # ---------------------------------------------------------------------------------------------    
    if ack2debug4yoke is True:
        print(33*("-"))
        print("YOKE4XI: RETURNING ", time4xi())                                                                     # 05:22:05 02/01/11 Pacific Standard Time  
        print(33*("-"))
        

#</program4xi>
         
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   sense*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of yoke4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>            

